/* Program4_1
 *
 * "Yes" szveget kldnk ki 2 msodpercenknt a FRDM-KL25Z
 * krtya UART0 Tx kimenetn keresztl a szmtgp fel
 * az OpenSDA ltal biztostott virtulis soros portra.
 * 
 * Hasznljunk valamilyen terminl emultor programot (PUTTy.exe,
 * Termite, TeraTerm stb.) az zenetek megjelentshez. 
 * Bellts: 9600 bps, 8N1, adatfolyam vezrls nlkl.
 *
 * Alaprtelmezetten SystemInit() 20.97 MHz FLL rajelet llt be.  
 * BDH=0, BDL=0x88, s OSR=0x0F belltsokkal 9600 Baud lesz a sebessg.
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter4/Program4_1.txt
 */

#include <MKL25Z4.h>

void UART0_init(void);
void delayMs(int n);

int main (void) {
    UART0_init();                      // UART0 kimenet inicializlsa  
    while (1) {
        while(!(UART0->S1 & 0x80));    // Vrunk, mg res lesz a kimeneti buffer!
        UART0->D = 'Y';                // karakter klds
        while(!(UART0->S1 & 0x80));    // Vrunk, mg res lesz a kimeneti buffer!
        UART0->D = 'e';                // karakter klds
        while(!(UART0->S1 & 0x80));    // Vrunk, mg res lesz a kimeneti buffer!
        UART0->D = 's';                // karakter klds
        delayMs(2000);                 // Vrunk egy kicsit...
    }
}

/* UART0 Tx inicializlsa 9600 Baud tviteli sebessgre
 * Baudrate = UART0 clock freq / [OSR+1] / BDH:BDL
 * Esetnkben 20.97 MHz / [15 + 1] / 0x00:0x88 =  9637 bps, 
 * ami elfogadhat eltrs a nvlegestol.
 */
void UART0_init(void) {
    SIM->SCGC4 |= 0x0400;        // UART0 perifria engedlyezse
    SIM->SOPT2 |= 0x04000000;    // MCGFLLCLK vlasztsa UART0 baudrate rajelnek
    UART0->C2 = 0;               // UART0 letiltsa a konfigurls idotartamra
    UART0->BDH = 0x00;           // Baudrate = 9600 bps (bit8 - bit12) 
    UART0->BDL = 0x88;           // Baudrate = 9600 bps (bit0 - bit7)
	  UART0->C4 = 0x0F;            // Tlmintavtelezsi arny = 16
    UART0->C1 = 0x00;            // 8-bites adatformtum
    UART0->C2 = 0x08;            // Adatklds engedlyezse

    SIM->SCGC5 |= 0x0200;        // PORTA engedlyezse
    PORTA->PCR[2] = 0x0200;      // PTA2 legyen UART0_Tx zemmdban
}

/* Ksleltet fggvny: Vrakozs n milliszekundumig
 * A CPU rendszerrajel alaprtelmezett rtke 20.97152 MHz
 */
void delayMs(int n) {
    int i;
    int j;
    for(i = 0 ; i < n; i++)
        for (j = 0; j < 3500; j++) {}
}
