/* Program4_2
 *
 * Karakter fogadsa terminl emultorbl (PUTTy.exe,
 * Termite, TeraTerm stb.) OpenSDA ltal biztostott virtulis 
 * soros porton kereeztl, a FRDM-KL25Z krtya UART0 Rx
 * bemenetn. A vett karakter legals bitjeivel az RGB LED
 * llapott vezreljk. Az RGB LED inicailizlsa s vezrlse
 * hasonlan trtnik, mint Program2_7-ben.
 *
 * Hasznljunk valamilyen terminl emultor programot (PUTTy.exe,
 * Termite, TeraTerm stb.) a karakter kikldshez! A kikldtt
 * karaktert ebben a programban a FRDM krtya nem tkrzi vissza.
 * gyeljnk r, hogy a terminl emultor ne fuzzn a kikldtt
 * karakterhez sorvge jelzst! Pldul a Termite program
 * Settings menjben "Append nothing" bellts kell.
 * Bellts: 9600 bps, 8N1, adatfolyam vezrls nlkl.
 *
 * Alaprtelmezetten SystemInit() 20.97 MHz FLL rajelet llt be.  
 * BDH=0, BDL=0x88, s OSR=0x0F belltsokkal 9600 Baud lesz a sebessg.
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter4/Program4_2.txt
 */

#include <MKL25Z4.h>

void UART0_init(void);                  // UART0 Rx bemenet inicializlsa
void LED_init(void);                    // RGB LED inicializlsa

int main (void) {
	  char c; 
    UART0_init();                       // UART0 Rx bemenet inicializlsa  
	  LED_init();                         // RGB LED inicializlsa
    while (1) {
        while(!(UART0->S1 & 0x20));     // Adatberkezsre vrunk
        c = UART0->D;                   // Kiolvassuk a vett karaktert
        if (c & 1) PTB->PCOR = 0x40000; // Piros LED: BE (bit18 = 0)
            else PTB->PSOR = 0x40000;   // Piros LED: KI           (bit18 = 1)    
        if (c & 2) PTB->PCOR = 0x80000; // Zld LED: BE  (bit19 = 0)
            else PTB->PSOR = 0x80000;   // Zld LED: KI            (bit19 = 1)
        if (c & 4) PTD->PCOR = 0x02;    // Kk LED: BE   (bit1  = 0)
            else PTD->PSOR = 0x02;      // Kk LED: KI             (bit1  = 0)
    }
}

/* UART0 Rx inicializlsa 9600 Baud tviteli sebessgre
 * Baudrate = UART0 clock freq / [OSR+1] / BDH:BDL
 * Esetnkben 20.97 MHz / [15 + 1] / 0x00:0x88 =  9637 bps, 
 * ami elfogadhat eltrs a nvlegestol.
 */
void UART0_init(void) {
    SIM->SCGC4 |= 0x0400;        // UART0 perifria engedlyezse
    SIM->SOPT2 |= 0x04000000;    // MCGFLLCLK vlasztsa UART0 baudrate rajelnek
    UART0->C2 = 0;               // UART0 letiltsa a konfigurls idotartamra
    UART0->BDH = 0x00;           // Baudrate = 9600 bps (bit8 - bit12) 
    UART0->BDL = 0x88;           // Baudrate = 9600 bps (bit0 - bit7)
	  UART0->C4 = 0x0F;            // Tlmintavtelezsi arny = 16
    UART0->C1 = 0x00;            // 8-bites adatformtum
    UART0->C2 = 0x04;            // Adatfogads engedlyezse

    SIM->SCGC5 |= 0x0200;        // PORTA engedlyezse
    PORTA->PCR[1] = 0x0200;      // PTA1 legyen UART0_Rx zemmdban
}

/* RGB LED inicializlsa Program2_7 alapjn */
void LED_init(void) {
    SIM->SCGC5 |= 0x400;         // Port B engedlyezse
    SIM->SCGC5 |= 0x1000;        // Port D engedlyezse
    PORTB->PCR[18] = 0x100;      // PTB18 legyen GPIO (MUX = 1)
    PTB->PDDR |= 0x40000;        // PTB18 legyen kimenet (bit18)
    PTB->PSOR = 0x40000;         // Piros LED lekapcsolsa (negatv logika!)
    PORTB->PCR[19] = 0x100;      // PTB19 legyen GPIO (MUX = 1)
    PTB->PDDR |= 0x80000;        // PTB19 legyen kimenet (bit19=1)
    PTB->PSOR = 0x80000;         // Zld LED lekapcsolsa (negatv logika!)
    PORTD->PCR[1] = 0x100;       // PTD1 legyen GPIO  (MUX = 1)
    PTD->PDDR |= 0x02;           // PTD1 legyen GPIO (MUX = 1)
    PTD->PSOR = 0x02;            // Kk LED lekapcsolsa (negatv logika!)
}
