/* Program4_3
 *
 * "Hello" szveget kldnk folyamatosan a FRDM-KL25Z
 * krtya UART2 Tx kimenetn keresztl. Hasznljunk egy
 * USB-soros talaktt s valamilyen terminl emultor 
 * programot (PUTTy.exe, Termite, TeraTerm stb.) az zenetek 
 * megjelentshez!
 * Belltsok: 9600 bps, 8N1, adatfolyam vezrls nlkl.
 *
 * Alaprtelmezetten a buszfrekvencia is 20.97 MHz (FLL rajel).  
 * BDH=0, BDL=0x88 belltsokkal 9600 Baud lesz a sebessg.
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter4/Program4_3.txt
 */

#include <MKL25Z4.h>

void UART2_init(void);                   // UART2 kimenet inicializlsa 
void delayMs(int n);                     // Kslelteto fggvny

int main (void) {
    char message[] = "Hello\r\n";        // Ez lesz a kirand szveg
    int i;                               // Ciklusvltoz
    UART2_init();   	
    while (1) {
        for (i = 0; i < 7; i++) {			
            while(!(UART2->S1 & 0x80));  // Vrunk, mg res lesz a kimeneti buffer!
            UART2->D = message[i];       // Kvetkezo karakter kldse					
        }
        delayMs(2000);                   // Vrunk egy kicsit...
    }
}

/* UART2 Tx (PTE22) inicializlsa 9600 Baud tviteli sebessgre
 * Baudrate = bus freq / 16 / BDH:BDL
 * Esetnkben 20.97 MHz /2 / 16 / 0x00:0x44 =  9637 bps, 
 * ami elfogadhat eltrs a nvlegestol.
 * Megjegyzs: UART2 rajele a buszfrekvencia, tlmintavtelezs arnya mindig 16
 */
void UART2_init(void) {
    SIM->SCGC4 |= 0x1000;        // UART2 perifria engedlyezse
    UART2->C2 = 0;               // UART2 letiltsa a konfigurls idotartamra
    UART2->BDH = 0x00;           // Baudrate = 9600 bps (bit8 - bit12) 
    UART2->BDL = 0x44;           // Baudrate = 9600 bps (bit0 - bit7)
    UART2->C1 = 0x00;            // 8-bites adatformtum
	  UART2->C3 = 0x00;            // Nincs hibainterrupt
    UART2->C2 = 0x08;            // Adatklds engedlyezse

    SIM->SCGC5 |= 0x2000;        // PORTE engedlyezse (bit 13)
    PORTE->PCR[22] = 0x0400;     // PTE22 legyen UART2_Tx zemmdban (Alt4)
}

/* Ksleltet fggvny: Vrakozs n milliszekundumig
 * A CPU rendszerrajel alaprtelmezett rtke 20.97152 MHz
 */
void delayMs(int n) {
    int i;
    int j;
    for(i = 0 ; i < n; i++)
        for (j = 0; j < 3500; j++) {}
}
